---
# https://www.digitalocean.com/community/tutorials/how-to-install-and-use-docker-on-ubuntu-22-04

- name: Only run "update_cache=yes" if the last one is more than 3600 seconds ago
  ansible.builtin.apt:
    update_cache: true
    cache_valid_time: 3600

- name: Ensure old versions of Docker are not installed.
  ansible.builtin.package:
    name:
      - docker
      - docker-engine
      - docker.io
      - containerd
      - runc
    state: absent

- name: Ensure dependencies are installed.
  ansible.builtin.apt:
    name:
      - apt-transport-https
      - ca-certificates
      - curl
      - gnupg
      - lsb-release
    state: present
    update_cache: true

- name: Add Docker apt key.
  ansible.builtin.apt_key:
    url: "{{ docker_apt_gpg_key }}"
    id: 9DC858229FC7DD38854AE2D88D81803C0EBFCD88
    state: present
  register: add_repository_key
  ignore_errors: "{{ docker_apt_ignore_key_error }}"

- name: Add Docker repository
  ansible.builtin.apt_repository:
    repo: "{{ docker_apt_repository }}"
    state: present
    update_cache: true

- name: Install Docker packages
  ansible.builtin.apt:
    name: "{{ docker_packages }}"
    state: "{{ decker_packages_state }}"
    update_cache: true
  notify:
    - Configure Docker to start on boot
    - Configure Сontainerd to start on boot

- name: Ensure group {{ docker_group }} exists with correct gid
  ansible.builtin.group:
    name: "{{ docker_group }}"
    state: present
    gid: 1750

- name: Ensure docker users are added to the {{ docker_group }} group
  ansible.builtin.user:
    name: "{{ item }}"
    groups: "{{ docker_group }}"
    append: true
  loop: "{{ docker_users }}"
